"""
Aplicação para o cálculo do fator de atrito e da perda de carga
"""
# importando bibliotecas
from fator_atrito import ECB, pcarga

# declarando dados de entrada para o cálculo do fator de atrito
f1 = 1      # estimativa da resposta
f = 0       # estimativa da resposta 2
e = 2.5e-5  # fator de rugosidade em metros
D = 0.3     # diâmetro do tubo em metros
Re = 2.3e03 # número de Reynolds (adimensional)

# chamando a função de Colebrook-White para resolução do nosso problema
[f1, n] = ECB(f1, f, e, D, Re, 1)
print('O valor do fator de atrito f é:', format(f1, '.5f'))

# declarando dados de entrada para o cálculo da perda de carga
L = 100 # é o comprimento do tubo (metros)
v = 2.2 # é a velocidade do fluido no tubo (m/s)

# chamando a função de perda de carga da tubulação
perda = pcarga(f1, D, L, v)
msg = 'A perda de carga para a tubulação de'
print(msg, L, 'metros é', format(perda, '.2f'), 'metros')
print('Foram necessárias ', n, 'repetições')

    