# importando bibliotecas
from math import log10, sqrt
def ECB(f1, f, e, D, Re, n):
    # onde D é o diâmetro do tubo (metros);
    # Re Número de Reynolds (adimensional);
    # e é o fator de rugosidade da tubulação (metros);
    try:
        if abs(f1 - f) < 10e-7:
            return [f1, n]
        else:
            f = f1
            n = n+1
            f1 = 1/(-2*log10((e/(D*3.7)) + (2.51/(Re*sqrt(f)))))**2
            return ECB(f1, f, e, D, Re, n)
    except ZeroDivisionError:
            print('Reveja seus argumentos. Houve um erro de divisão por zero.')
    
def pcarga(f, D, L, v):
    # onde D é o diâmtro do tubo (metros);
    # f é o fator de atrito (adimensional);
    # L é o comprimento do tubo (metros);
    # v é a velocidade do fluido no tubo (m/s);
    g = 9.81 #aceleração da gravidade (m/s**2).
    
    perda = f*(L/D)*v**2/(2*g)
    return perda

