# usando a função de ajuste de curva
from numpy import array, polyfit, poly1d

# nossos dados experimentais
x = array([1, 2, 3, 4, 5])
y = array([2.5, 10.6, 16, 14.3, 8.2])

# calculando os coeficientes
d, c, b, a = polyfit(x, y, 3)

# transformando os coeficientes em uma função
func = poly1d([d, c, b, a])
print('função proposta:\n', func)
# obtendo a 1a derivada
dfdx = func.deriv()
print('\nprimeira derivada:\n', dfdx)
# obtendo a 2a derivada
d2fdx = func.deriv(2)
print('\nsegunda derivada:', d2fdx)

# usando as funções obtidas
x1 = 3.5
y1=func(x1)
print(f'\nPara x ={x1:.1f} temos f(x) = {y1:.1f}')
y2=dfdx(x1)
print(f'\nPara x ={x1:.1f} temos dfdx(x) = {y2:.1f}')
y3=d2fdx(x1)
print(f'\nPara x ={x1:.1f} temos d2fdx(x) = {y3:.1f}')

