# importando bibliotecas
from scipy.stats import linregress
import matplotlib.pyplot as p
from numpy import linspace

# declaração dos valores de x e y
x = [18, 4, 17, 8, 15, 9, 7, 0, 1, 19]
y = [51.18928319, 50.86117792, 75.11608179, 56.56277441, 
     63.58298867, 33.56582313, 49.40456839, 16.85865487, 
     35.56720695, 73.23549166]

# calculando os coeficientes da reta
resultados = linregress(x, y)
b = resultados[0]                     # coeficiente angular
a = resultados[1]                     # coeficiente linear
r2 = resultados[2]**2                 # r quadrado

# imprimindo o resultado de r2
print(f'coeficiente angular b = {b:.3f}')
print(f'coeficiente linear a = {a:.3f}')
print(f'r2 ={r2:.3f}')

# desenvolvimento da função
func = lambda x: x*b + a
x2 = linspace(min(x),max(x),20)       # valores de x para a função

# plotando o gráfico da dispersão e da regressão em uma figura só
p.clf()                               # limpando figura existente
p.scatter(x, y)                       # gráfico de dispersão
p.plot(x2, func(x2), '-k')            # plotando o gráfico
p.title('Usando Regressão Linear')    # Título
p.xlabel('x')                         # legenda do eixo X
p.ylabel('y')                         # legenda do eixo Y
p.legend([fr'{b:.3f}*x + {a:.3f}','dispersão']) # legenda do gráfico
p.grid(color='k', linestyle='-', linewidth=0.1) # linhas de grade
p.show()                              # mostrando o gráfico

