# importando bibliotecas
from sympy import symbols
from sympy import solve
from numpy import linspace
import matplotlib.pyplot as p

# tornando uma variável simbólica
x = symbols('x')

# declarando uma equação
y = 3*x**2 - 6*x + 3
print('A raiz da Equação 1 é:', solve(y), '\n')

# sistema de equações
x1, y1 = symbols('x1 y1')
Eq1 = 12 - (x1 + y1)
Eq2 = 5 - (-x1 + y1)

# resolvendo o sistema de equações
sols = solve([Eq1, Eq2])
print('Os valores de x1 e y1 são:', sols, 'respectivamente')

# plotando nossos dados e nossa equação em um gráfico 
# dados para x
x2 = linspace(0, 10, 100)
y0 = lambda x: 3*x**2 - 6*x + 3
y3 = lambda x: 12 - x  
y4 = lambda x: 5 + x

p.clf()  # limpando gráfico anterior, se existir

# plotando 1° gráfico
p.subplot(1, 2, 1)                             
p.plot(x2, y0(x2), 'b*',  markersize=3)                   
p.title('Observando o comportamento da função y')        # título
p.xlabel('x')                                            # legenda do eixo X
p.ylabel('y')                                            # legenda do eixo Y
p.legend(['y(x)'])                 #legenda do gráfico
p.grid(color='k', linestyle='-', linewidth=0.1)          # linhas de grade

# plotando 2° gráfico
p.subplot(1, 2, 2)                             
p.plot(x2, y3(x2), 'b--', x2, y4(x2), 'r-', markersize=3) 
p.plot(sols[x1], y4(sols[x1]), 'ko',  markersize=7)                          
p.title('Observando a interseção das duas retas')        # título
p.xlabel('x')                                            # legenda do eixo X
p.ylabel('y(x)')                                         # legenda do eixo Y
p.legend(['Eq1', 'Eq2', 'interseção'])                   # legenda do gráfico
p.grid(color='k', linestyle='-', linewidth=0.1)          # linhas de grade
p.show()
