# usando a função de ajuste de curva
from numpy import array, polyfit, poly1d, corrcoef
import matplotlib.pyplot as p

# nossos dados experimentais
x = array([1, 2, 3, 4, 5])
y = array([2.5, 7, 9.2, 14.8, 22.4])

# calculando os coeficientes
b, a = polyfit(x, y, 1)

#imprimindo resultados dos coeficientes
print('E o coeficiente angular é', format(b, '.3f'))
print('O coeficiente linear é', format(a, '.3f'))

# calculando o quanto a função consegue representar os dados
r = corrcoef(x, y)[0,1]
r2 = r**2

# imprimindo o resultado de r2
print('r2 = ', format(r2, '.3f'))

# transformando os coeficientes angular e linear em uma função
func = poly1d([b, a])

# transformando nossa equação em texto que será plotado no gráfico
ftxt = 'y = ' + str(format(b, '.3f')) + '*x ' + str(format(a, '.3f')) + '\n' 

# transformando o resultado do cálculo de r2 em texto para o graf
rtxt = 'r2 = ' + str(format(r2, '.3f'))

# plotando nossos dados e nossa equação em um gráfico 
p.clf()                              # limpando gráfico anterior, se existir
p.plot(x,y, 'bo', x, func(x), '-k')  # plotando o gráfico
p.title('Usando ajuste de curvas')   # título
p.xlabel('x')                        # legenda do eixo X
p.ylabel('y')                        # legenda do eixo Y
p.legend(['y', ftxt + rtxt])         # legenda do gráfico
p.xlim(0, 6)                         # definindo os limites do eixo x
p.ylim(0, 25)                        # definindo os limites do eixo y
p.grid(color='k', linestyle='-', linewidth=0.1) #linhas de grade
p.show()                             # mostrando o gráfico

