# usando a função de ajuste de curva
# importando bibliotecas
from numpy import array, poly1d, flip, linspace
from numpy.polynomial.polynomial import polyfit
import matplotlib.pyplot as p

# nossos dados experimentais
x = array([0, 1, 2, 3, 4, 5, 6]) 
y = array([-2,  2,  4,  4,  2, -2, -8])

# usando o polifit do pacote polynomial do numpy
c, outros = polyfit(x,y,2,full=True)
c = flip(c)
#imprimindo resultados
print('c = ', c, 'outros=', outros)

# soma dos quadrados dos resíduos
sqr = outros[0]
# calculando o valor de r2
ym = (y - (sum(y)/len(y)))**2
r2 = 1- (sqr/sum(ym))[0]

# imprimindo o resultado de r2
print('r2 = ', format(r2, '.3f'))

# transformando os coeficientes angular e linear em uma função
func = poly1d(c)
x2 = linspace(0, 6, 30)
# transformando nossa equação em texto que será plotado no gráfico
ftxt = 'y = ' + str(format(c[0], '.3f')) + '*x^2 +' + str(format(c[1], '.3f'))
ftxt = ftxt  + '*x ' + str(format(c[2], '.3f')) + '\n' 

# transformando o resultado do cálculo de r2 em texto para plotagem no grafico
rtxt = 'r2 = ' + str(format(r2, '.3f'))

# plotando nossos dados e nossa equação em um gráfico 
p.clf()                                # limpando gráfico anterior, se existir
p.plot(x,y, 'bo', x2, func(x2), '-k')  # plotando o gráfico
p.title('Usando ajuste de curvas')     # Título
p.xlabel('x')                          # legenda do eixo X
p.ylabel('y')                          # legenda do eixo Y
p.legend(['y', ftxt + rtxt])           # legenda do gráfico
p.xlim(0, 7)                           # definindo os limites do eixo x
p.ylim(-10, 5)                         # definindo os limites do eixo y
p.grid(color='k', linestyle='-', linewidth=0.1) #linhas de grade
p.show()                               # mostrando o gráfico

