# importando bibliotecas
import sympy

# tornando variáveis simbólicas
T, B= sympy.symbols('T B')

# descrevendo o sistema de equações (lineares!)
eq1 = T + B - 100            #Equação 14.23
eq2 = 0.05*B + 0.95*T - 40   #Equação 14.24
eq3 = 0.40*B + 0.04*T - 26   #Equação 14.25
eq4 = 0.55*B + 0.01*T - 34   #Equação 14.26

# resolvendo o sistema de equações com o solve
# duas incógnitas, duas equações
sol = sympy.solve([eq1, eq2], [T, B])

# testando a solução
r1 = eq1.subs({T:sol[T], B:sol[B]})
r2 = eq2.subs({T:sol[T], B:sol[B]})
r3 = eq3.subs({T:sol[T], B:sol[B]})
r4 = eq4.subs({T:sol[T], B:sol[B]})

# lista de soluções
rs = [r1,r2,r3,r4]

# imprimindo os resultados 
if abs(sum(rs)) <= 1e-7:
    msg = f'Os valores de B = {sol[B]:.2f}mol/h e ' 
    msg = msg + f'T= {sol[T]:.2f}mol/h resolvem o sistema.'
    print(msg)
else:
    msg = f'Os valores de B = {sol[B]:.2f}mol/h '
    msg = msg + f'e T= {sol[T]:.2f}mol/h NÃO RESOLVEM o sistema.'
    print(msg)
    
