# importando bibliotecas
from numpy import linalg, matrix

# tomando o formato da função como sendo Ax = b
# escrevendo a matriz A
A = matrix([[0.05, 0.95],       # Constantes da Equação 14.24
            [0.40, 0.04]])      # Constantes da Equação 14.25
# escrevendo um vetor coluna b
b = matrix([[40.],              # Resultado da Equação 14.24
            [26.]])             # Resultado da Equação 14.25

# obtendo os valores de x (no caso B e T)
x = linalg.solve(A, b) #x = A\b
# testando a solução no sistema de equações
br = A*x
print('o resultado da multiplicação entre A e x deve ser igual a b.')
print('A*x =\n',br)
print('e b =\n',b)

# testando a solução para as demais equações
B = x[0,0]; T = x[1,0]
#descrevendo o sistema de equações (lineares!)
eq1 = B + T - 100               # Equação 14.23
eq2 = 0.05*B + 0.95*T - 40      # Equação 14.24
eq3 = 0.40*B + 0.04*T - 26      # Equação 14.25
eq4 = 0.55*B + 0.01*T - 34      # Equação 14.26

# lista de soluções
rs = [eq1,eq2,eq3,eq4]

# imprimindo os resultados
msg = f'Os valores de B = {B:.2f}mol/h e ' 
if abs(sum(rs)) <= 1e-7:
    msg = msg + f'T= {T:.2f}mol/h resolvem o sistema.'
    print(msg)
else:
    msg = msg + f'T= {T:.2f}mol/h NÃO RESOLVEM o sistema.'
    print(msg)


