# importando bibliotecas
from numpy import matrix
from scipy import linalg

# tomando o formato da função como sendo Ax = b
# escrevendo a matriz A
A = matrix([[0.01, 0.10, 0.95],     # Constantes da Equação 14.40
            [0.04, 0.85, 0.04],     # Constantes da Equação 14.41
            [0.95, 0.05, 0.01]])    # Constantes da Equação 14.42
# escrevendo um vetor coluna b
b = matrix([[30.],                  # Resultado da Equação 14.40
            [35.],                  # Resultado da Equação 14.41
            [35.]])                 # Resultado da Equação 14.42

# obtendo os valores de x (no caso B1, B2 e T2)
x = linalg.solve(A, b) # x = A\b
# testando a solução no sistema de equações
br = A*x
print()
# testando a solução para as demais equações
B1 = x[0,0]; B2 = x[1,0]; T2 = x[2,0]
eq1 = B1 + B2 + T2 - 100             # Equação 14.39
# imprimindo os resultados 
msg = f'\nOs valores de B1 = {B1:.2f}mol/h, B2 = {B2:.2f}mol/h e\n'
if abs(sum(br-b)) <= 1e-7 and abs(eq1) <= 1e-7:
    print('O resultado da multiplicação Ax deve ser igual a b.')
    print('A*x =\n',br)
    print('e b =\n',b)
    msg = msg + f'T2= {T2:.2f}mol/h resolvem o sistema proposto.'
    print(msg)
else:
    msg = msg + f'T2= {T2:.2f}mol/h NÃO RESOLVEM o sistema.'
    msg = msg + '\nRevise as Equações e as constantes usadas.'
    print(msg)


