# importando bibliotecas 
from sympy import Integral, Symbol, pprint
# declaração de variáveis
T = Symbol('T')
R = 8.314          # J/mol.K
Ti = 27+273.15     # C --> K
Tf = 90+272.15     # C --> K
# constantes da Equação 14.10 para água
A = 8.712
B = 1.25E-3
C = -0.18E-6
# Capacidade Calorífica molar da água
fCp = R*(A + B*T + C*T**2)
print('Esta é a função original:')
pprint(fCp)
print(5*'--------------')

# chamando o método e integrando a função ∫(Cp/R)dT
Q = Integral(fCp, T).doit() # doit() manda integrar a função
print('\nEsta é a função integrada:')
pprint(Q)
print(5*'--------------')

# integrando a função como integral definida
Q2 = Integral(fCp, (T, Ti, Tf)).doit()
msg = '\nA quantidade de energia necessária é Q ='
print(msg + f' {Q2/1000:.2f}kJ/mol ou Q = {Q2/18:.1f}kJ/kg.')

# considerando que temos um custo de R$ 0,90/GJ  
msg = 'O custo de aquecimento de 1000kg/h de água é R$'
print(msg + f' {Q2/(1000*18)*0.90:.2f}.')



# exemplo semelhante 4.2 Van Ness Int. Term. Eng. Qui. 7a Ed pg. 97

