# importando bibliotecas 
from scipy.integrate import quad as integral

def funcCp(T, A, B, C):
    # Capacidade Calorífica molar da água
    fCp = R*(A + B*T + C*T**2)
    return fCp

# declaração de variáveis
R = 8.314          # J/mol.K
Ti = 27+273.15     # C --> K
Tf = 90+272.15     # C --> K
# constantes da Equação 14.10 para água
A = 8.712
B = 1.25E-3
C = -0.18E-6
# chamando o método e integrando a função ∫(Cp/R)dT no intervalo a-b
Q = integral(funcCp, Ti, Tf, args=(A,B,C))
msg = 'A quantidade de energia necessária é Q ='
print(msg + f' {Q[0]/1000:.2f}kJ/mol ou Q = {Q[0]/18:.1f}kJ/kg.')
# considerando que temos um custo de R$ 0,90/GJ  
msg = 'O custo de aquecimento de 1000kg/h de água é R$'
print(msg + f' {Q[0]/(1000*18)*0.90:.2f}.')



#exemplo semelhante 4.2 Van Ness Int. Term. Eng. Qui. 7a Ed pg. 97
