# importando bibliotecas
from scipy.integrate import solve_ivp
import matplotlib.pyplot as p

# equações difereiciais
def equacoes(x, Ca):
    k = 0.37
    u = 0.52
    Ca1, Ca2 = Ca
    dCadx = -(2*k*Ca1**2)/u
    dCbdx = (k*Ca1**2)/u
    return [dCadx,  dCbdx]

# condições iniciais
Ca0 = 1.85
Cb0 = 0.0
Ca = [Ca0, Cb0]

# intervalo do reator
x = [0, 2.5]

# resolve o sistem de equações
sol = solve_ivp(equacoes, x, Ca, max_step=0.1)
print(sol)

# plotando os resultados
p.clf()
p.plot(sol.t, sol.y[0], 'g-', sol.t, sol.y[1], 'b--')
p.xlabel('Comprimento do reator (x)')
p.ylabel(r'$dCi/dx$', fontsize = 12)
p.legend([r'$u(dC_A/dx)=-2kC_A^2$', r'$u(dC_B/dx)=kC_A^2$'],
          prop={'size': 12})
p.show() 

