from numpy import exp
# definindo a função objetivo
def func_objetivo(vals):
    # precentual de recuperação do investimento
    [Fa, Fb, Fr, Fra, Frb, Frc, Fre, Frp, Fg, Fp, Fd, T, V] = vals
    I = (100/(600*Vro(V)))*(8400*(0.3*Fp+0.0068*Fd-0.02*Fa-0.03*Fb-0.01*Fg) - 2.22*Fr - (0.124*8400)*(0.3*Fp+0.0068*Fd)-60*Vro(V))
    return (-I)

# definição das massas molares
def M(m):
    if m == 'b':
        val = 100.
    elif m == 'c':  
        val = 200.
    elif m == 'e':  
        val = 200.                
    elif m == 'g':  
        val = 300.                
    elif m == 'p':  
        val = 100.
    else:
        val = 1.                
    return val                
                
# definição das constantes de equilíbrio                
def K1(T):
    A1 = 5.9755e9
    B1 = 12000. #°Rankine
    k1 = A1*exp(-B1/T)
    return k1

def K2(T):
    A2 = 2.5962e12
    B2 = 15000. #°Rankine
    k2 = A2*exp(-B2/T)
    return k2

def K3(T):
    A3 = 9.6283e15
    B3 = 20000. #°Rankine
    k3 = A3*exp(-B3/T)
    return k3
# cálculo do volume do reator
def Vro(V):
    ro = 50.0
    return (V*ro)

# definindo as restrições
def g1(vals):
    [Fa, Fb, Fr, Fra, Frb, Frc, Fre, Frp, Fg, Fp, Fd, T, V] = vals
    return (Fa + Fb -Fg - Fp - Fd)
    
def g2(vals):
    [Fa, Fb, Fr, Fra, Frb, Frc, Fre, Frp, Fg, Fp, Fd, T, V] = vals
    return (Frp - 0.1*Fre - Fp)

def g3(vals):
    [Fa, Fb, Fr, Fra, Frb, Frc, Fre, Frp, Fg, Fp, Fd, T, V] = vals
    G3 = (M('e')/M('b'))*K2(T)*(Frb*Frc)*(Vro(V)/(Fr**2))- Fd*(Fre/(Fr - Fg - Fp))
    return (G3)

def g4(vals):
    [Fa, Fb, Fr, Fra, Frb, Frc, Fre, Frp, Fg, Fp, Fd, T, V] = vals
    G4 = (K2(T)*Frb*Frc - (M('p')/M('c'))*K3(T)*Frc*Frp)*(Vro(V)/(Fr**2)) - Fd*((Frp - Fp)/(Fr - Fg - Fp)) - Fp
    return (G4)

def g5(vals):
    [Fa, Fb, Fr, Fra, Frb, Frc, Fre, Frp, Fg, Fp, Fd, T, V] = vals
    G5 = (-K1(T)*Fra*Frb)*(Vro(V)/(Fr**2)) - Fd*(Fra/(Fr - Fg - Fp)) + Fa
    return (G5)

def g6(vals):
    [Fa, Fb, Fr, Fra, Frb, Frc, Fre, Frp, Fg, Fp, Fd, T, V] = vals
    G6 = (-K1(T)*Fra*Frb - K2(T)*Frb*Frc)*(Vro(V)/(Fr**2)) - Fd*(Frb/(Fr - Fg - Fp)) + Fb 
    return (G6)

def g7(vals):
    [Fa, Fb, Fr, Fra, Frb, Frc, Fre, Frp, Fg, Fp, Fd, T, V] = vals
    G7 = ((M('c')/M('b'))*(K1(T)*Fra*Frb) - (M('c')/M('b'))*K2(T)*Frb*Frc - K3(T)*Frc*Frp)*(Vro(V)/(Fr**2)) - Fd*(Frc/(Fr - Fg - Fp))
    return (G7)

def g8(vals):
    [Fa, Fb, Fr, Fra, Frb, Frc, Fre, Frp, Fg, Fp, Fd, T, V] = vals
    G8 = (M('g')/M('c'))*K3(T)*Frc*Frp*(Vro(V)/(Fr**2)) - Fg 
    return (G8)

def g9(vals):
    [Fa, Fb, Fr, Fra, Frb, Frc, Fre, Frp, Fg, Fp, Fd, T, V] = vals
    G9 = Fra + Frb + Frc + Fre + Fg + Frp - Fr
    return (G9)

def squadrado(vals):
    #soma dos quadrados dos desvios das restrições
    [Fa, Fb, Fr, Fra, Frb, Frc, Fre, Frp, Fg, Fp, Fd, T, V] = vals
    resps = [g1(vals), g2(vals), g3(vals), g4(vals), g5(vals),
             g6(vals), g7(vals), g8(vals), g9(vals)]
    soma = 0.
    for iten in resps: 
        soma = soma + iten**2
    return soma
