# importando bibliotecas
import pandas as pd
import matplotlib.pyplot as p
import funcs_Cartas_cap_16 as c
import Eqs_estatistica_cap16 as f

#----------------PARTE 1: CÁLCULO DAS ESTATÍSTICAS----------------------
# carregamento dos dados de temperatura (Tabela 16.6)
Dados = pd.read_excel('dados_temp_cap16.xlsx')
# transformando dados em uma lista do python
temperaturas = Dados.values.tolist()
# calculando a média
media = f.media1barra(temperaturas)     # Eq. 16.8
# calculando a amplitude R
amplitude = f.amplitudeR(temperaturas)  # Eq. 16.10
# calculando o desvio
desvio_pad = f.desvioPA(temperaturas)   # Eq. 16.12
# calculando a média das médias
media2b = f.media2barras(media)         # Eq. 16.9
# calculando a média da amplitude R
amplitude_media = f.mediaAmplitudeR(amplitude)  # Eq. 16.11
# calculando a média dos desvios
desvio_pad_medio = f.mediaDesvioPA(desvio_pad)  # Eq. 16.13

# obtendo a quantidade de replicatas (n) e de amostras (m)
n = len(temperaturas[0]); m = len(temperaturas)
x = list(range(1,m+1))                 # n° da amostra

#----------------PARTE 2: CONSTRUÇÃO DAS CARTAS DE CONTROLE------------
# calculo dos limites da carta de controle XR
[LSC, LC, LIC] = c.cartaXRmedias(media2b,amplitude_media, n, m)
[LSCr, LCr, LICr] = c.cartaXRamplitudes(amplitude_media, n, m)
# calculo dos limites da carta de controle XS
[LSCm, LCm, LICm] = c.cartaXSmedias(media2b,desvio_pad_medio, n, m)
[LSCs, LCs, LICs] = c.cartaXSdesvio(desvio_pad_medio, n, m)

# plotando os gráficos
p.clf()          # limpando gráfico anterior
#----------formatação e plotagem do gráfico 1------------#                                       
p.subplot(2,2,1) # n° de gráficos e posição do gráfico da média 
p.plot(x, media, '-*k', x, LC, '-b', x, LSC, '-r', x, LIC, '-r')                               
p.title('Carta X-R - Médias')                             # título
p.xlabel('Amostras')                             # legenda do eixo X
p.ylabel('Médias')                               # legenda do eixo Y
p.grid(color='k', linestyle='-', linewidth=0.1)  # linhas de grade

#----------formatação e plotagem do gráfico 2------------#
p.subplot(2,2,3) # definindo a posição do gráfico da amplitude
p.plot(x, amplitude, '-*k',x, LCr,'-b', x, LSCr, '-r', x, LICr, '-r')                               
p.title('Carta X-R - Amplitudes')                         # título
p.xlabel('Amostras')                             # legenda do eixo X
p.ylabel('Amplitude')                            # legenda do eixo Y
p.grid(color='k', linestyle='-', linewidth=0.1)  # linhas de grade

#----------formatação e plotagem do gráfico 3------------# 
p.subplot(2,2,2) # definindo a posição do gráfico da média 
p.plot(x, media, '-ok', x, LCm, '-b', x, LSCm, '-r', x, LICm, '-r')                               
p.title('Carta X-S - Médias')                             # título
p.xlabel('Amostras')                             # legenda do eixo X
p.ylabel('Médias')                               # legenda do eixo Y
p.grid(color='k', linestyle='-', linewidth=0.1)  # linhas de grade

#----------formatação e plotagem do gráfico 4------------#
p.subplot(2,2,4) # definindo a posição do gráfico do desvio padrão
p.plot(x, desvio_pad, '-ok',x, LCs,'-b',x, LSCs, '-r',x, LICs, '-r')                               
p.title('Carta X-S - Desvios')                         # título
p.xlabel('Amostras')                             # legenda do eixo X
p.ylabel('Desvio Padrão Amostral')               # legenda do eixo Y
p.grid(color='k', linestyle='-', linewidth=0.1)  # linhas de grade
p.tight_layout()
p.show()

