# importando biblioteca
from numpy import ones, zeros

# declaração das equações para a carta Média dados μ e σ
def cartaXSigma(media_mi, desvio_padrao_ro, n, m):
    # calcula os limites da carta de controle dados μ e σ
    estima_desvio = 3*desvio_padrao_ro/((n)**(1/2))
    LSC = (media_mi + estima_desvio)*ones(m)  # Eq. 16.5
    LC = media_mi*ones(m)                     # Eq. 16.6
    LIC = (media_mi - estima_desvio)*ones(m)  # Eq. 16.7
    return [LSC, LC, LIC]

# ---------------------------------------------------------------------------
# declaração das equações para a carta Média Amplitude - XR
def cartaXRmedias(x2barras, Rbarra, n, m):
    # para a média
    d2 = d2tabela(n)
    LSC = (x2barras + 3*Rbarra/(d2*n**0.5))*ones(m) # limite superior controle
    LC = x2barras*ones(m)                           # linha central
    LIC = (x2barras - 3*Rbarra/(d2*n**0.5))         # limite inferior controle
    if LIC > 0.0:
        LIC = LIC*ones(m)
    else:
        LIC = LIC*zeros(m)
    return [LSC, LC, LIC]

def cartaXRamplitudes(Rbarra, n, m):
    # para a amplitude
    D3 = D3tabela(n)
    D4 = D4tabela(n)
    LSCa = (D4*Rbarra)*ones(m) # limite superior controle
    LCa = Rbarra*ones(m)       # linha central
    LICa = (D3*Rbarra)         # limite inferior controle
    if LICa < 0.0:
        LICa = LICa*zeros(m)
    else:
        LICa = LICa*ones(m)  
    return [LSCa, LCa, LICa]

# ---------------------------------------------------------------------------
# declaração das equações para a carta Média Desvio Padrão Amostral - XS
def cartaXSmedias(x2barras, Sbarra, n, m):
    # para a média
    c4 = c4tabela(n)
    LSCm = (x2barras + 3*Sbarra/(c4*n**0.5))*ones(m) # limite superior controle
    LCm = x2barras*ones(m)                           # linha central
    LICm = (x2barras - 3*Sbarra/(c4*n**0.5))         # limite inferior controle
    if LICm > 0.0:
        LICm = LICm*ones(m)
    else:
        LICm = LICm*zeros(m)    
    return [LSCm, LCm, LICm]

def cartaXSdesvio(Sbarra, n, m):
    # para a amplitude
    c4 = c4tabela(n)
    # limite superior controle
    LSCd = Sbarra*(1 + (3/c4)*(1-c4**2)**(0.5))*ones(m)
    # linha central
    LCd = Sbarra*ones(m) 
    # limite inferior controle
    LICd = Sbarra*(1 - (3/c4)*(1-c4**2)**(0.5)) 
    if LICd < 0.0:
        LICd = LICd*zeros(m)
    else:
        LICd = LICd*ones(m)      
    return [LSCd, LCd, LICd]
# dados das constantes da Tabela 16.5
def c4tabela(n):
    if n <= 1:
        print('Use valores de n (replicatas) >=2 ou n <=10.')
    if n > 1 and n < 11:
        valores_c4 = [0.7979,0.8862, 0.9213, 0.9400, 0.9515,
                      0.9594, 0.9650, 0.9693, 0.9727]
        use = valores_c4[n-2]         
    else:
        use = 0
        print('valor não disponível. Procure bibliografia.')
    return use 
def d2tabela(n):
    if n <= 1:
        print('Use valores de n (replicatas) >=2 ou n <=10.')
    if n > 1 and n < 11:
        valores_d2 = [1.128, 1.693, 2.059, 2.326,
                      2.534, 2.704, 2.847, 2.970, 3.078]
        use = valores_d2[n-2]         
    else:
        use = 0
        print('valor não disponível. Procure bibliografia.')
    return use        
def D3tabela(n):
    if n <= 1:
        print('Use valores de n (replicatas) >=2 ou n <=10.')
    if n > 1 and n < 11:
        valores_D3 = [0.0, 0.0, 0.0, 0.0, 0.0, 0.076, 0.136,
                      0.184, 0.223]
        use = valores_D3[n-2]         
    else:
        use = 0
        print('valor não disponível. Procure bibliografia.')
    return use             
def D4tabela(n):
    if n <= 1:
        print('Use valores de n (replicatas) >=2 ou n <=10.')
    if n > 1 and n < 11:
        valores_D4 = [3.267, 2.575, 2.282, 2.115, 2.004, 
                      1.924, 1.864, 1.816, 1.777]
        use = valores_D4[n-2]         
    else:
        use = 0
        print('valor não disponível. Procure bibliografia.')
    return use                 
            
            
            
            
            
            
            