# importando biblioteca
import pandas as pd
import matplotlib.pyplot as p
import funcs_Cartas_cap_16 as f
from Eqs_estatistica_cap16 import media1barra

# carregamento dos dados de composição de A (Tabela 16.4)
Dados = pd.read_excel('composi_A.xlsx')
# transformando dados em uma lista do python
composiA = Dados.values.tolist()
# dados de referência
mi = 0.965            # valor de μ conforme especificação
sigma = 0.0087        # valor de σ conforme especificação
n = len(composiA[0])  # número de replicatas
m = len(composiA)     # número de amostras

# calculando os limites da carta de controle
LSC, LC, LIC = f.cartaXSigma(mi, sigma, n, m)
amostras = list(range(1,len(composiA)+1)) # n° da amostras

#calculando a média xbarra de cada grupo de amostras de A
medias = media1barra(composiA) # Eq. 16.8

#----------formatação e plotagem do gráfico ------------#
p.clf()                        # limpando gráfico anterior                                       
p.plot(amostras, medias, '-*k', 
       amostras, LC, '-b', 
       amostras, LSC, '-r', 
       amostras, LIC, '-r')                               
p.title('Para a média')                         # título
p.xlabel('Amostras')                            # legenda do eixo X
p.ylabel(r'Médias $X ̅_i$')                      # legenda do eixo Y
p.legend([r'$X ̅_i$','LC', 'LSC', 'LIC'],        # legenda das curvas
         loc='best', bbox_to_anchor=(0.2, 0.953))
p.grid(color='k', linestyle='-', linewidth=0.1) # linhas de grade

