# definição das funções com as regras de controle
def testeregra1(LSC, LC, LIC, medias):
    # Regra 1: dois pontos fora do limite da carta
    m = len(medias)
    regra = []
    for i in range(m):
        if medias[i] > LSC or medias[i] < LIC:    # teste da regra 1
            msg = f' -A {i+1}a medida, {medias[i]:.2f}, está fora do limite.'
            print(msg)
            regra.append(msg)
    if len(regra) >= 2:
        msg = 'Planta fora de controle estatístico. Quebra da regra 1:'
        msg2 = ' -Dois ou mais pontos fora dos limites da carta.'
        regra.insert(0,msg)
        regra.insert(0,msg2)
    elif len(regra) == 1:
        msg = 'Atenção! Um ponto fora dos limites de da carta.'
        regra.insert(0,msg)
    else:
        regra = ['Planta sob controle estatístico.']
    return regra

def testeregra2(medias):
    # Regra 2: 6 pontos consecutivos crescentes ou decrescentes
    m = len(medias)
    regra = []
    c = 0
    i = 0
    amostras =  6 
    if m > 5:
        # testes para os valores crescentes
        while i < m-1:
            if medias[i+1] > medias[i]:
                c += 1
                if c == amostras:
                    regra.append(i-5)
                    regra.append(i+1)
                    direc = 'crescentes'
                    break        
            else:
                c = 0
            i+=1
        # testes para os valores decrescentes
        if c < amostras:
            c = 0
            i = 0            
            while i < m-1:
                if medias[i+1] < medias[i]:
                    c += 1
                    if c == amostras:
                        regra.append(i-5)
                        regra.append(i+1)
                        direc = 'decrescentes'
                        break       
                else:
                    c = 0
                i+=1            
    if c == amostras:
        msg = 'Planta fora de controle estatístico. Quebra da regra 2:'
        msg2 = f' -Temos 6 valores {direc} entre as'
        msg2 = msg2 + f'amostras {regra[0]} e {regra[1]}.'
        print(msg, msg2)
        regra2 = [msg, msg2]
        
    else:
        regra2 = ['Planta sob controle estatístico.']
    return regra2        
        
def testeregra3(LC, medias):
    # Regra 3: 8 pontos consecutivos acima ou abaixo da LC
    m = len(medias)
    regra = []
    c = 0
    i = 0
    amostras =  8
    if m > 7:
        # testes para os valores acima da LC
        while i < m-1:
            if medias[i] > LC:
                c += 1
                if c == amostras:
                    regra.append(i-7)
                    regra.append(i)
                    direc = 'acima'
                    break        
            else:
                c = 0
            i+=1
        # testes para os valores abaixo da LC
        if c < amostras:
            c = 0
            i = 0            
            while i < m-1:
                if medias[i] < LC:
                    c += 1
                    if c == amostras:
                        regra.append(i-7)
                        regra.append(i)
                        direc = 'abaixo'
                        break        
                else:
                    c = 0
                i+=1          
    if c == amostras:
        msg = 'Planta fora de controle estatístico. Quebra da regra 3:'
        msg2 = f' -Temos 8 amostras ({regra[0]}a a {regra[1]}a) {direc} da LC.'  
        print(msg, msg2)
        regra3 = [msg, msg2]
        
    else:
        regra3 = ['Planta sob controle estatístico.']
    return regra3     
        
def testeregra4(medias):
    # Regra 4: 14 pontos consecutivos com oscilação decrescentes e decrescente
    m = len(medias)
    regra = []
    c = 0
    i = 0
    troca = True
    troca2 = True
    amostras = 14 
    if m > 13:
        # testes para os valores crescentes
        while i < m-1:
            # teste para os valor crescente
            if (medias[i+1] > medias[i]) and troca:
                c += 1
                troca = False
                troca2 = True
            # teste para os valor decrescente
            elif (medias[i+1] < medias[i]) and troca2:
                c += 1
                troca = True
                troca2 = False            
            else:
                c = 0
            if c == amostras:
                regra.append(i-13)
                regra.append(i+1)
                break  
            i+=1
          
    if c == amostras:
        msg = 'Planta fora de controle estatístico! Quebra da regra 4:'
        msg2 = f' -Temos 14 pontos consecutivos ({regra[0]} a {regra[1]})'
        msg2 = msg2 + f' oscilando para cima e para baixo.'
        print(msg, msg2)
        regra4 = [msg, msg2]
        
    else:
        regra4 = ['Planta sob controle estatístico.']
    return regra4      
                
def relatorioCarta(LSC, LC, LIC, medias):
    planta_controlada = 'Planta sob controle estatístico.'
    planta_ncontrolada = 'Planta fora de controle estatístico.'
    print('Para a regra 1 - Dois ou mais pontos fora dos limites:')
    regra1 = testeregra1(LSC[0], LC[0], LIC[0], medias)
    if regra1[0] == 'Planta sob controle estatístico.':
        print(planta_controlada)
    else:
        print(planta_ncontrolada)
    
    msg = '- 6 pontos consecutivos crescentes ou decrescentes:'
    print('\nPara a regra 2', msg)
    regra2 = testeregra2(medias)
    if regra2[0] == 'Planta sob controle estatístico.':
        print(planta_controlada)
   
    print('\nPara a regra 3 - 8 pontos consecutivos acima ou abaixo da LC:')    
    regra3 = testeregra3(LC[0], medias)
    if regra3[0] == 'Planta sob controle estatístico.':
        print(planta_controlada)    
    
    msg = '14 pontos consecutivos com oscilação decrescentes e decrescente:'
    print('\nPara a regra 4 -', msg)     
    regra4 = testeregra4(medias)
    if regra4[0] == 'Planta sob controle estatístico.':
        print(planta_controlada)
    
    
    
    
    
    
    
    
    
    
    
    
    
    
    
    
    
    
    
    
    