# declaração das variáveis - dados para 20°C
db = 0.8765     # kg/L densidade do benzeno
dt = 0.8660     # kg/L densidade do tolueno
Pb0 = 562.5     # kPa pressão de vapor do benzeno puro
Pt0 = 165.01    # kPa pressão de vapor do tolueno puro
MMb = 78.11     # g/mol massa molar do benzeno
MMt = 92.14     # g/mol massa molar do tolueno
vb = 55         # litros de benzeno
vt = 25         # litros de touleno

# antes da Equação 7 - cálculo da massa dos reagentes
mb = db*vb  # massa de tolueno kg
mt = dt*vt  # massa de benzeno kg

# equação 7 - cálculo da quantidade de matéria
nb = mb/MMb     # quantidade de matéria do benzeno
nt = mt/MMt     # quantidade de matéria do tolueno

# equação 6 - cálculo da fração molar dos compostos
xb = nb/(nb + nt)   # fração molar do benzeno na solução
xt = 1 - xb         # fração molar do tolueno na solução

# equação 5 - Cálculo da pressão parcial
Pb = xb*Pb0     # pressão parcial do benzeno kPa
Pt = xt*Pt0     # pressão parcial do tolueno kPa

# equação 8 - Cálculo da pressão de vapor da mistura
P = Pb + Pt     # somatório das pressões parciais kPa

msg = 'A pressão de vapor da mistura é de '
print(msg, format(P,'.2f'), 'kPa. \n')
msg2 = 'A sugestão de compra deve ser um'
msg2 += '\nmanômetro que mensure pressões'
msg2 += '\nentre 0 e 600.00 kPa'
print(msg2)

