# importando biblioteca
import matplotlib.pyplot as p

# declarando variáveis
perfis = [90, 95, 87]                  # eficiências do reator
numero_de_barras = len(perfis)         # medindo o tamanho da lista
posicoes = range(numero_de_barras)     # gerando uma lista de posições

p.clf() # limpando figuras anteriores
#usando argumentos para a função bar
p.bar(posicoes, perfis, align='center', width=0.5,
       hatch=['o-','//','--'], color=['green', 'blue','orange'] )
# ajustando a nomenclatura do eixo para cada barra
legendas = ['Manhã', 'Tarde', 'Noite'] # legenda para cada uma das barras
p.xticks(posicoes, legendas)           # colocando legenda para cada barra
inter1 = list(range(0,71,10))          # lista com passo de 10 em 10
inter2 = list(range(80,101,5))         # lista com passo de 5 em 5
p.yticks(inter1 + inter2)              # concatenando e aplicando no eixo y
p.ylabel('Eficiência do reator (%)')           # legenda do eixo y
p.xlabel('Turno de trabalho')                  # legenda do eixo x
p.title('Gráfico da eficiência de um reator')  # título do gráfico

# definindo as linhas de grade
p.grid(color='k', linestyle='-', linewidth=0.1)
p.show()                                       # mostrando o gráfico

