# importando biblioteca 
import matplotlib.pyplot as p

# declarando variáveis
consumo = [1.2, 4.3, 0.9, 0.5]           # consumo trimestral
numero_de_barras = len(consumo)          # medindo o tamanho da lista
posicoes = range(numero_de_barras)       # gerando uma lista de posições

p.clf() # limpando figuras anteriores
# usando argumentos para a função barh
p.barh(posicoes, consumo, align='center', color="green", height=0.4)

# ajustando a nomenclatura do eixo para cada barra
# legenda para cada uma das barras
legendas = ['Primavera', 'Verão', 'Outono', 'Inverno']      
p.yticks(posicoes, legendas)               # legenda para cada barra
p.ylabel('Estação do ano')                 # legenda do eixo y
p.xlabel('Consumo Energético (MJ/h)')           # legenda do eixo x
p.title('Gráfico da eficiência de um reator')   # título do gráfico

# definindo as linhas de grade
p.grid(color='k', linestyle='-', linewidth=0.1)
p.show()                                        # mostrando gráfico

