# importando bibliotecas
from matplotlib import pyplot as p

# gerando uma lista com 10 horas
horas = list(range(1,11))

# dados de fluxos mássicos
fluxos = [12164.25, 12126.98, 12088.39, 12012.22, 12195.9, 12051.05, 
          12221.31, 12100.56, 12262.08, 12291.61]
# dados de fração mássica
fracoes = [0.96, 0.95, 0.97, 0.97, 0.96, 0.96, 0.98, 0.98, 0.95, 0.99]

# plotando o gráfico
p.clf()                          # limpando figura anterior
p.close('all')                   # fechando qualquer figura anterior
fig = p.figure()                 # criando uma instância chamada fig
eixo_padrao = fig.add_subplot()  # adicionando uma subplotagem à figura

copia_do_eixo = eixo_padrao.twinx()       # gerando uma cópia do eixo y
fluxo, = eixo_padrao.plot(horas, fluxos, 'o-b')     # plotando 1° eixo y
fracao, = copia_do_eixo.plot(horas, fracoes, '>--g')# plotando 2° eixo y

eixo_padrao.set_xlabel('tempo(h)')                  # legenda do eixo X
eixo_padrao.set_ylabel('Fluxo (kg/h)')              # legenda do 1° eixo Y
copia_do_eixo.set_ylabel('Fração mássica')          # legenda do 2° eixo Y

eixo_padrao.set_xlim(0, 12)            # ajuste de intervalo do eixo x 
eixo_padrao.set_ylim(12000, 12300)     # ajuste de intervalo do 1° eixo  Y 
copia_do_eixo.set_ylim(0.95, 1)        # ajuste de intervalo do 2° eixo  Y 

p.title('Variação do fluxo e da fração mássica de A')  # título
curvas = [fluxo, fracao]               # definição das curvas para legendas
# legenda do gráfico                 
eixo_padrao.legend(curvas, ['Fluxo Mássico (kg/h)', 'Fração Mássica'])

# linhas de grade para o 1° eixo Y
eixo_padrao.grid(True, color='k', linestyle='-', linewidth=0.1)
# linhas de grade para o 2° eixo Y
copia_do_eixo.grid(True, color='k', linestyle='-', linewidth=0.1)
p.show()                               # mostrando o gráfico

