# importando bibliotecas
import matplotlib.pyplot as p
import numpy as np
from pylab import meshgrid

# declaração de variáveis
r = np.linspace(0.5, 3, 20)
h = np.linspace(0.1, 2, 20)

# gerando uma malha de dados
R,H = meshgrid(r, h)

# calculando os custos de aquisição com os valores da malha
Custos = (((2*np.pi*R**2)/np.sqrt(2))*(1 + np.pi*H)**1/3)

# gerando uma figura independente
fig=p.figure()
# configurando a dimensão da figura
dim = fig.subplots(subplot_kw={"projection": "3d"})

# aplicando legendas nos eixos x, y e z
dim.set_xlabel("Valores do Raio (m)")
dim.set_ylabel("Valores da Altura (m)")
dim.set_zlabel("Custo de Aquisição (R$x1000)")

# plotando os dados de x, y e z
dim.plot_surface(R, H, Custos, linewidth=0, antialiased=True, cmap='Greens')
# mostrando o gráfico
p.show()

