# importando bibliotecas
from matplotlib import pyplot as p

# gerando uma lista com horas de operação
tempo = list(range(10))

# fração molar do composto A
A = [1.268079352, 0.470159149, 0.164334798, 1.605562735, 2.435614276,
     3.509253597, 2.921953797, 2.007998705, 1.102427459, 3.786450768]
# fração molar do composto B
B = [5.178726065, 4.600117087, 5.264764822, 4.196859217, 5.484963238,
     5.779989552, 4.979395473, 4.240223122, 4.543103945, 5.990870166]
# vazão de alimentação do processo
Q = [1047.042271, 1076.179893, 1086.990295, 1020.514289, 1010.201706,
     1005.986257, 1037.2172, 1058.395585, 1068.371784, 1093.534129]

# gráfico da variação da fração molar
# definindo n° de linhas, n° de colunas e posição do gráfico
p.subplot(1, 2, 1)          
p.plot(tempo, A, 'k-o')     # plotando o gráfico
p.plot(tempo, B, 'r-*')     # plotando o gráfico
p.xlabel('tempo (h)')       # legenda do eixo X
p.ylabel('Frações molares de A e B')                     # legenda do eixo Y
p.title('Variação das composições A e B com o tempo (h)')# título do gráfico
p.legend(['A', 'B'])        # legenda do gráfico
p.grid(color='k', linestyle='-', linewidth=0.1)          # linhas de grade

# gráfico da vazão de alimentação
# definindo n° de linhas, n° de colunas e posição do gráfico
p.subplot(1, 2, 2)
p.plot(tempo, Q, 'b--x')    # plotando o gráfico
p.xlabel('tempo (h)')       # legenda do eixo X
p.ylabel('kmol/h')          # legenda do eixo Y
p.title('Variação da vazão Q com o tempo (h)')           # título do gráfico
p.legend(['Q(kmol/h)'])     # legenda do gráfico
p.grid(color='k', linestyle='-', linewidth=0.1)          # linhas de grade
p.show()                    # mostrando o gráfico


