# importando bibliotecas
import numpy as np
import matplotlib.pyplot as p

# declaração de variáveis
mi = 0.89e-3           # viscosidade dinâmica do fluido - Pa.s = kg/m.s
v = 4.5                # velocidade média do fluido - m/s
D = 3/100              # diâmetro do tubo - m
ro = 997.05            # massa específica - kg/m3
f = 0                  # fator de atrito estimado
epsilon = 4.57e-5      # rugosidade do tubo (m)
L = 15                 # comprimento do tubo (m)
f1 = 100               # fator de atrito calculado
n = 0                  # estimativa inicial do contador
erro = 1e-2            # estimativa inicial do erro absoluto

# cálculo do número de Reynolds
Re = ro*D*v/mi         # Eq. 6.1 

# realizando os testes para a determinação do regime
if Re <= 2300.0:
    msg = 'laminar'
elif Re > 2300.0 and Re <= 4000.0:
    msg = 'transiente'
else:
    msg = 'turbulento'
# imprimindo o resultado
print('O Re calculado foi de', format(Re, '.1f'), '\nLogo, o regime é', msg)

