# importando bibliotecas
import math as m
import numpy as np
import matplotlib.pyplot as p

# declarações de variáveis
h = 3           # altura do tanque (m)
V = 45          # volume do tanque (m3)
n = 1           # contador
fr = 1          # estimativa inicial de fv

#---gerando dados para a construção de um gráfico de fv versus r
f = []
r = np.linspace(0.1 , 5, 30)           # criando um intervalo linear
for ri in r:
    f.append(((m.pi*(ri)**2)/3)*(6-(h-2)/ri) - V)
    
#---visualizando o comportamento de fv em um gráfico
# plotando o gráfico
p.plot(r, f, 'k-*')                             # plotando o gráfico
p.xlabel('r (m)')                               # legenda do eixo X
p.ylabel('f(r)')                                # legenda do eixo Y
p.title('f(r) X r')                             # título
p.legend(['f(r)'])                              # legenda do gráfico
p.grid(color='k', linestyle='-', linewidth=0.1) # linhas de grade
p.show()                                        # mostrar a figura
p.pause(5)                                      # pausa
print('\nContinuando a resolução do problema.')
    
# estimativa inicial de r
r0 = float(input('Entre com o valor da estimativa de r(m): '))

# repita até que a condição seja alcançada
while (abs(fr) > 1e-7 and n < 1000):
    fr = ((m.pi*(r0)**2)/3)*(6-(h-2)/r0) - V
    dfr = 4*m.pi*r0 - (m.pi/3)*(h-2)
    r1 = r0 - (fr/dfr)
    r0 = r1
    n += 1    
# imprimindo o resultado
print('O raio calculado foi de %.2f metros' %r1)
print('Para encontrar a solução, foram necessárias %i iterações' %n)

