# declaração de variáveis
n = 0                      # contador
Q = 20                     # vazão (m3/s)
g= 9.81                    # aceleração da gravidade (m/s2)
xu = 2.1                   # estimativa do valor máximo de y
xe = 1.5                   # estimativa do valor mínimo de y
# observe que aqui xr = y nas equações 8.29 e 8.30
# estimativa de xr somente para o cálculo do erro
xr = (xe + xu)/2
B = 3 + xr                          # Equação 8.29
Ac = 3*xr + (xr**2)/2               # Equação 8.30
fxr = 1- ((Q**2)*B)/(g*Ac**3)       # Equação 8.28
#---método de regula-falsi---
while (abs(fxr) > 1e-9 and n < 100):
    n += 1                                 #contador
    # calculando os valores com base em xu
    B = 3 + xu                             # Equação 8.29
    Ac = 3*xu + (xu**2)/2                  # Equação 8.30
    fxu = 1- ((Q**2)*B)/(g*Ac**3)          # Equação 8.28
    # calculando os valores com base em xe
    B = 3 + xe                             # Equação 8.29
    Ac = 3*xe + (xe**2)/2                  # Equação 8.30
    fxe = 1- ((Q**2)*B)/(g*Ac**3)          # Equação 8.28
    xr = xu -  (fxu*(xe - xu))/(fxe - fxu) # Equação 8.34
    # calculando os valores com base em xr
    B = 3 + xr                             # Equação 8.29
    Ac = 3*xr + (xr**2)/2                  # Equação 8.30
    fxr = 1 - ((Q**2)*B)/(g*Ac**3)         # Equação 8.28
    # substituição dos limites inferior ou superior
    if (fxr*fxu > 0):
        xu = xr
    elif (fxr*fxe > 0):
        xe = xr
    else:
        print('\nfim\n')
        break
# imprimindo os resultados
print('O número de iterações foi igual a %d' %n)    
msg = 'A raiz encontrada foi igual a %.2f'
print (msg %xr)
msg1 = 'Com um erro numérico de %.4e'
print(msg1 %(fxr))

